package listFW.visitor;

import listFW.*;

/**
 * Counts all elements in an IList of IList.
 * @author sw
 */
public class CountAll2 implements IListAlgo {
    public static final CountAll2 Singleton = new CountAll2();
    private CountAll2() {
    }
    
    public Object emptyCase(IMTList host, Object nu) {
        return new Integer(0);
    }
    
    public Object nonEmptyCase(final INEList host, Object nu) {
        return ((IList)host.getFirst()).execute(new IListAlgo() {
            public Object emptyCase(IMTList hostFirst, Object acc) {
                return host.getRest().execute(CountAll2.this, null);
            }
            public Object nonEmptyCase(INEList hostFirst, Object acc) {
                return new Integer( 1+ ((Integer)hostFirst.getRest().execute(this, null)).intValue());
            }
        }, null); 
    }
}