package listFW.visitor;

import listFW.*;

/**
 * Counts all elements in an IList of IList.
 * @author dxn
 */
public class CountAll implements IListAlgo {
    public static final CountAll Singleton = new CountAll();
    private CountAll() {
    }
    
    public Object emptyCase(IMTList host, Object notUsed) {
        return new Integer(0);
    }
    
    public Object nonEmptyCase(INEList host, Object notUsed) {
        return ((IList)host.getFirst()).execute(new IListAlgo() {
            public Object emptyCase(IMTList hostFirst, Object acc) {
                return acc;
            }
            public Object nonEmptyCase(INEList hostFirst, Object acc) {
                return hostFirst.getRest().execute(this, new Integer(1 + ((Integer)acc).intValue()));
            }
        }, host.getRest().execute(this, null)); 
    }
}