package listFW.visitor;

import listFW.*;

/**
 * Counts all elements in an IList of IList.
 * @author sw
 */
public class CountAll_TailRec2 implements IListAlgo {
  public static final CountAll_TailRec2 Singleton = new CountAll_TailRec2();
  private CountAll_TailRec2() {
  }
  
  public Object emptyCase(IMTList host, Object nu) {
    return new Integer(0);
  }
  
  public Object nonEmptyCase(final INEList host, Object nu) {
    return ((IList)host.getFirst()).execute(new IListAlgo() {
      public Object emptyCase(IMTList hostFirst, Object acc) {
        return host.getRest().execute(Helper, acc);
      }
      public Object nonEmptyCase(INEList hostFirst, Object acc) {
        return hostFirst.getRest().execute(this, new Integer(1 + ((Integer)acc).intValue()));
      }  
    }, new Integer(0));
  }
  
  
  private static final IListAlgo Helper = new IListAlgo() { 
    public Object emptyCase(IMTList host, Object acc) {
      return acc;
    }
    public Object nonEmptyCase(final INEList host, Object acc) {
      return ((IList)host.getFirst()).execute(new IListAlgo() {
        public Object emptyCase(IMTList hostFirst, Object acc) {
          return host.getRest().execute(Helper, acc);
        }
        public Object nonEmptyCase(INEList hostFirst, Object acc) {
          return hostFirst.getRest().execute(this, new Integer(1+((Integer)acc).intValue()));
        }
      }, acc); 
    }
  };
}