package lrs.visitor;

import lrs.*;

/**
 * Removes the minimum Integer element from an LRStruct containing Integers.
 * What should be done in the case the list is empty?
 * @author DXN
 */
public class SelectionSortLRS implements IAlgo {

    public static final SelectionSortLRS Singleton = new SelectionSortLRS();
    private SelectionSortLRS() {
    }

    public Object emptyCase(LRStruct host, Object nu) {
        return host;
    }

   public Object nonEmptyCase(LRStruct host, Object inp) {
        host.insertFront(host.execute(RemMinLRS.Singleton, null));
        host.getRest().execute(this, null);
        return host;
    }
}


